﻿
init python:
    def rot_reset(trans, st, at):
        if trans.rotate == 360:
            trans.rotate = 0
            return None
    class roulette_class:
        def __init__(self):
            self.speed = 0
            self.rot = 0
            self.t = 0
            self.current = None
            self.y = 0
            self.numbers = [
                [0, "G"],
                [32, "R"], [15, "B"], [19, "R"], [4, "B"], [21, "R"], [2, "B"], [25, "R"], [17, "B"], [34, "R"],
                [6, "B"], [27, "R"], [13, "B"], [36, "R"], [11, "B"], [30, "R"], [8, "B"], [23, "R"], [10, "B"],
                [5, "R"], [24, "B"], [16, "R"], [33, "B"], [1, "R"], [20, "B"], [14, "R"], [31, "B"], [9, "R"],
                [22, "B"], [18, "R"], [29, "B"], [7, "R"], [28, "B"], [12, "R"], [35, "B"], [3, "R"],[26, "B"],
            ]
        def rotate(self):
            self.speed += 100

        def throw(self):
            r = renpy.random.randint(0,36)
            while r == self.current:
                r = renpy.random.randint(0,36)
            self.current = r
            if self.y == 1:
                self.y = 0
            else:
                self.y = 1
        def tick(self):
            self.rot += self.speed
            if self.speed > 1:
                self.speed -= 1

default roulette = roulette_class()

screen roulette_screen(g = roulette):
    modal True
    vbox:
        yalign .5 spacing 10
        button:
            background "#0009" xalign 1.0
            text "Rotate the wheel hon!"
            action Function(g.rotate)
        button:
            background "#0009" xalign 1.0
            text "Throw The ball!"
            action Function(g.throw)
    
    timer 2 repeat True action Function(g.tick)
    frame:
        align .25,.5 background None
        frame:
            xysize 708,708 align .5,.5 background "roulette/roulette.png"
            at roulette_rotate(g.rot)
            for n,i in enumerate(g.numbers):
                frame:
                    xysize 50,600 align .5,.5 background None # "roulette/{}.png".format(i[1])
                    text str(i[0]) align .5,0.0
                    at roulette_transform(n)
            if g.current:
                frame:
                    ysize 476 align .5,.5 background None
                    at roulette_ball_rotate(g.current)
                    add "roulette/ball.png" align .5,0.0 at roulette_ball_offset(g.y)
                

transform roulette_transform(n):
    subpixel  True
    transform_anchor True
    # alignaround (0.0, 0.5)
    rotate n*9.729


transform roulette_rotate(n):
    subpixel  True
    transform_anchor True
    linear 2 rotate n
    function rot_reset
transform roulette_ball_rotate(n):
    subpixel  True
    transform_anchor True
    rotate 760
    easein 3 rotate n*9.729

transform roulette_ball_offset(y):
    subpixel  True
    yoffset -108
    pause 2
    easein .5 yoffset -86
    ease_bounce .5 yoffset y

label roulette_example:
    show screen roulette_screen
    pause

